#pragma once

#include "TextData.h"
#include "SceneInfo.h"

#include <vector>
#include <memory>

class RootNode;
class AbstractVisualNode;
class SceneItem;

class Scene
{
public:
    Scene();

    ~Scene();

    void addNode(AbstractVisualNode* node);

    const std::vector<SceneItem*>& getItems() const;

    bool isEmpty() const;

    bool shouldShowMeshOutline() const;

    void setShowMeshOutline(bool shouldShow);

    void update(FontsManager* fontsManager = nullptr);
private:
    void updateNode(AbstractVisualNode* node);

    std::unique_ptr<RootNode> mRootNode;
    std::vector<SceneItem*> mSceneItems;
    std::unique_ptr<SceneInfo> mSceneInfo;
};
